/**
 * Project: MentDB
 * Description: Mentalese Database Engine
 * Website: http://www.mentdb.org
 * Twitter: https://twitter.com/mentalese_db
 * LinkedIn: https://www.linkedin.com/company/mentdb
 * Facebook: https://www.facebook.com/mentdb
 * Author: Jimmitry Payet
 * Website: http://www.jpayet.re
 * Mail: contact@jpayet.re
 * Locality: Reunion Island (French)
 */

package re.jpayet.mentdb.core.entity.data_type;

import java.io.IOException;

import org.json.simple.JSONArray;
import org.json.simple.JSONObject;

import re.jpayet.mentdb.core.entity.concentration.ConcentrationManager;
import re.jpayet.mentdb.core.entity.link.LinkManager;
import re.jpayet.mentdb.core.entity.relation.RelationManager;
import re.jpayet.mentdb.tools.Misc;

public class DataTypeManager {
	
	public static JSONArray array = new JSONArray();
	
	//Load all data types
	@SuppressWarnings("unchecked")
	public static void reload(String cuser) throws Exception {
		
		//Initialization
		array = new JSONArray();
		
		JSONArray data_types = RelationManager.showTabLinks(cuser, "["+LinkManager.get_value("@[r_fr_?_est_un_type_de_donnée]")+" 2/3]", "L", ConcentrationManager.getConcentrationDepth("C[relation]"));
		
		//Parse all data type relation tab links
		for(int i=0;i<data_types.size();i++) {
			
			//Get the current tab link
			String currentTabLink = data_types.get(i)+"";
			
			String relationId = Misc.atom(currentTabLink, 1, " ").substring(1);
			
			//Get the condition
			JSONObject mqls = RelationManager.getDco(cuser, relationId, "dco");
			
			String mqlCondition = "true;";
			
			for(Object o : mqls.keySet()) {
				
				String key = (String) o;
				
				String mql = (String) mqls.get(key);
				
				if (mqlCondition.equals("true;")) mqlCondition = mql;
				else mqlCondition = "and ("+mqlCondition+") ("+mql+");";
				
			}
			
			JSONObject obj = new JSONObject();
			obj.put("relation_id", Misc.atom(Misc.atom(relationId, 2, "\\["), 1, "\\]"));
			obj.put("condition", mqlCondition);
			array.add(obj);
			
		}
		
	}
	
	public static JSONArray show() throws IOException {
		
		return array;
		
	}
	

}
